
#include <pic.h>
#include "process.h"

#define DELAY_P1 5000
#define DELAY_P2 25000

// process functions declaration
void Process_A( void );
void Process_B( void );

// process pointers declaration
T_P_Process p1;
T_P_Process p2;
T_P_Process pmain;

unsigned char Temp_PORTB = 0;

// main function
void main( void )
{

   p1 = New_Process( (T_Process) &Process_A, 0 );
   p2 = New_Process( (T_Process) &Process_B, 0 ); 

   PORTB = 0; // PORTB initialization to zero
   TRISB = 0; // PORTB digital outputs

   // transfer the control to the process 1
   Transfer( pmain, p1 );


   // the calling of the function is only to produce the object code 
   Process_A(); // do not eliminate
   Process_B(); // do not eliminate
}

// Process 1
void Process_A( void )
{
   static unsigned short n = 0;

   while( 1 )
      {
      // toggle the RB0 bit
      Temp_PORTB ^= 1 << 0;
      PORTB = Temp_PORTB;
      for( n = 0; n < DELAY_P1; n++ )
         {
          asm("nop");
          Transfer( p1, p2 );
          asm("nop");
         }
      }
}

// Process 2
void Process_B( void )
{
   static unsigned short n = 0;

   while( 1 )
      {
      // toggle the RB1 bit
      Temp_PORTB ^= 1 << 1;
      PORTB = Temp_PORTB;
      for( n = 0; n < DELAY_P2; n++ )
         {
          asm("nop");
          Transfer( p2, p1 );
          asm("nop");
         }
      }
}
